%Exercice 1 : COMPLEXITE

%Nombre de points constants:100, T fct du degr
%**********************************************

clear
x=0:0.02:2
y=cos(x.^5)+0.2*randn (size(x))
y=y'
XVander=vander (x)
X=[]
B=[]
for k=0:1:100
	X=XVander(1:101,100-k:101);
	t=cputime;
	a=(X'*X)\X'*y;
	B(k+1)=cputime-t;
	end;
k=1:1:100
plot (k,B,'c'),hold on;
axis ([0 110 0 0.12])

%Degr constant:20, T fct du nombre de points
%********************************************

%clear
x=0:0.02:2
ytous=cos(x.^5)+0.2*randn (size(x))
ytous=ytous'
XVander=vander (x)
X=[]
B=[]
for N=2:1:100
	X=XVander(1:N,1:101);
	y=ytous(1:N,1:1);
	t=cputime;
	a=(X'*X)\(X'*y);
	B(N)=cputime-t;
	end;
N=1:1:100
plot (N,B,'r'), hold off;
axis([0 110 0 0.12])

----------------------------------------------------------

%Exercice 2 : STABILITE

%Question a et b
%***************

%Methode 1 pour n = 30

clear
a=1
for i=0:1:29
        a=a*(1/3);
        end;
a

%Methode 2 pour n = 30

clear
b=[];
b(1)=1;
b(2)=1/3;
for i=3:1:31
        b(i)=(4/3)*b(i-1)-(1/3)*b(i-2);
	end;
b(31)

%Methode 3 pour n = 30

clear
c=[];
c(1)=1;
c(2)=1/3;
for i=3:1:31
        c(i)=(10/3)*c(i-1)-c(i-2);
	end;
c(31)

%Question c
%**********

%Methode 3 pour n = 10

clear
c=[];
c(1)=1;
c(2)=1/3;
for i=3:1:11
        c(i)=(10/3)*c(i-1)-c(i-2);
	end;
c(11)
1/(3.^10)

%Mthode 1 pour n = 50

clear
a=1
for i=0:1:49
        a=a*(1/3);
        end;
a
1/(3.^50)

%Methode 2 pour n = 50

clear
b=[];
b(1)=1;
b(2)=1/3;
for i=3:1:51
        b(i)=(4/3)*b(i-1)-(1/3)*b(i-2);
	end;
b(51)
1/(3.^50)